<?php
namespace Geral\Repositories;

class Solicita extends \Doctrine\ORM\EntityRepository
{

    /**
     * Valida Filial Solicitante
     * @param $cdfilal
     * @param $nrorg
     * @return array
     */
    public function verificaParametrosFilialSolicitante($cdfilal, $nrorg)
    {
        $sql = "
        SELECT PARASUPRI.IDJUSSOLEXT,
            PARASUPRI.IDBLOQALTNEC,
            PARASUPRI.IDAUDALTSOL,
            PARASUPRI.IDULTIDTULTI,
            PARASUPRI.IDULTCOMPSOL,
            PARASUPRI.IDULTDESTSOL,
            PARASUPRI.IDUTQTDEVOLU,
            PARASUPRI.IDBAIXSOLDFS,
            PARCMPSUP.IDUTPRODPREF,
            PARCMPSUP.IDUTAPROVSOL,
            PARCMPSUP.IDUTLOPERSOL,
            PARCMPSUP.IDPERALTSAPR,
            NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AS CDFILCENTCMP,
            FILCENT.NMFILIAL                          AS NMCENTCMP,
            PARCMPSUP.IDIMPINCSOLAPR,
            PARAMGERAL.IDRESTRFILIOPER
        FROM PARCMPSUP,
            PARASUPRI,
            FILIAL,
            FILIAL FILCENT,
            PARAMGERAL
        WHERE FILIAL.CDFILIAL  = :P_CDFILIAL
        AND FILIAL.NRORG = :P_NRORG
        AND FILCENT.NRORG = FILIAL.NRORG
        AND (PARASUPRI.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL))
        AND (PARCMPSUP.CDFILIAL = FILIAL.CDFILIAL)
        AND (FILCENT.CDFILIAL   = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL))
        ";

        $params = array(':P_CDFILIAL' => $cdfilal, ':P_NRORG' => $nrorg);

        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $params);

        return $result;
    }

    public function deleteSolicita($cdfilsoli,$cdfillan,$nrsoli){
        try{
            $sql = "DELETE SOLICITA WHERE NRSOLICMP = '$nrsoli' AND CDFILSOLI = '$cdfilsoli' AND CDFILLANCA = '$cdfillan' ";
            return $this->getEntityManager()->getConnection()->executeQuery($sql);
        }catch(\Exception $e){
            throw $e;
        }
    }

}