<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 16/07/14
 * Time: 10:04
 */

namespace Importacao\Logic\Integracao\Mastermaq;

use Importacao\Logic\IO\UploadArquivoMastermaq;

class IntegracaoMastermaq {

    CONST COMPLETO = 1;
    CONST PERSONALIZADO = 2;
    CONST ARQUIVO_MIGRACAO_ZIP = "Arquivos_Migracao_HRM.zip";

    public static function geraXls($endArquivo, $nrorg, $tipo = self::COMPLETO)
    {
        $arquivo = new UploadArquivoMastermaq($nrorg);
        $endArquivo = $arquivo->salvaArquivo($endArquivo);
        $arquivos = $arquivo->retornaArquivos($endArquivo, $tipo);

        if (empty($arquivos)) {
            throw new \Exception("Não foi possível descompactar o arquivo.");
        }

        $destino = APP_PATH."/files/upload/".$nrorg."/Mastermaq/data";

        if (!file_exists($destino)) {
            mkdir($destino , 0777, true);
        }

        if($tipo == self::COMPLETO){
            $xls = new IntegraCompleto($destino, '', $arquivos);
            $xls->gerar();
        } else {
            $xls = new IntegraPersonalizado($destino, '', $arquivos);
            $xls->gerar();

            $arquivo->compactarArquivos($destino);

            $arquivo->limparDiretrio($nrorg);
        }

        return true;

    }

    private function getExtensao($arquivo)
    {
        $pattern = "/\.(.*)$/";
        preg_match($pattern, $arquivo, $result);

        return $result[0];
    }

    public static function downloadTutorialMastermaq() {
        $arquivo = substr($_SERVER['REQUEST_URI'], 0, strlen($_SERVER['REQUEST_URI']) - 12)."/files/download/Especificação_Migração_HRM.pdf";
        $arquivo = new \TkFile($arquivo, false);
        $arquivo->download();
    }

    public static function downloadArquivoMigracaoZip($nrorg) {
        $arquivoZip = realpath(APP_PATH."/files/upload/$nrorg/Mastermaq/data/".self::ARQUIVO_MIGRACAO_ZIP);
        $arquivo = new \TkFile($arquivoZip, false);
        $arquivo->download();
    }
} 